//
//  AlgorithmTool.h
//  OYGameSKD
//
//  Created by duowan123 on 2021/4/27.
//  Copyright © 2021 jiketeam. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface AlgorithmTool : NSObject

//优先计算校验位--无误再进行数据处理  数据前面所有字节数相加是否等于最后一位
+(BOOL)verificationRusult:(NSData*)characteristicValue;

//测试
+(Byte)bbcByte:(Byte *)bytes;

//bbc
+(Byte)byteSumBBC:(NSData *)data;

//Data To Char：返回1Byte的char数据
+(char)dataToChar:(NSData *)data;

//Data To Short：返回2Byte的short数据  数据溢出要大小端转换
+(short)dataToSwapBigShortToHost:(NSData*)data andRange:(NSRange)range;

//Data To Int：返回 不定个数 Byte的int数据
+(int)dataToInt:(NSData*)data;

//Data To Int：返回 不定个数 Byte的int数据 数据溢出要大小端转换
+(int)dataToSwapBigIntToHost:(NSData*)data andRange:(NSRange)range;

//十六进制数据流转字符串
+(NSString *)hexadecimalString:(NSData *)data;

//字符串转16进制NSData数据流
+(NSData *)convertHexStrToData:(NSString *)str;

//json字符串转字典
+(NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString;

@end

NS_ASSUME_NONNULL_END
