
#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface GameObjc : NSObject
+ (instancetype)new NS_UNAVAILABLE;
- (instancetype)init NS_UNAVAILABLE;
- (instancetype)initWithGametype:(int)gametype NS_DESIGNATED_INITIALIZER;

- (void)gameProcess:(int)timeStamp
           rightPos:(int *)rightPos
           rightAtt:(int *)rightAtt
          rightZupt:(int)rightZupt
        right_press:(int)right_press
            leftPos:(int *)leftPos
            leftAtt:(int *)leftAtt
           leftZupt:(int)leftZupt
         left_press:(int)left_press
               jump:(int)jump
               down:(int)down
               rssi:(int)rssi
         girl_shoes:(int)girl_shoes;

- (void)runGameProcess:(int *)rightPos
              rightAtt:(int *)rightAtt
             rightZupt:(int)rightZupt
            leftPos:(int *)leftPos
               leftAtt:(int *)leftAtt
              leftZupt:(int)leftZupt
                  jump:(int)jump
                  down:(int)down
            girl_shoes:(int)girl_shoes;

- (void)getGameResult:(int *)matrix;

- (int)getStepFreq:(int)leftOrRight;
- (int)getStepStatus:(int)leftOrRight;
- (int)getStepCount:(int)leftOrRight;

- (float)getGamePos:(int)left_or_right index:(int)index;

- (void)start;
- (void)end;
- (void)isBingo;
-(int)getInteractionCMD;

/// 向外提供，手动释放,如需要，可调用
- (void)handRelease;

@end


@interface RunGameObjc : NSObject
- (int)getResultLeftRight:(int *)pos
                   devNum:(short)devNum;
- (int)getResultJump:(short)jump;
- (int)getResultDown:(short)down;
- (void)setResultConLeft:(short)zupt;
- (void)setResultConRight:(short)zupt;
- (int)getResultLeft:(int *)pos girl_shoes:(int)girl_shoes;
- (int)getResultRight:(int *)pos girl_shoes:(int)girl_shoes;
- (void)process:(int *)rightPos
       rightAtt:(int *)rightAtt
      rightZupt:(int)rightZupt
        leftPos:(int *)leftPos
        leftAtt:(int *)leftAtt
       leftZupt:(int)leftZupt
           jump:(int)jump
           down:(int)down
     girl_shoes:(int)girl_shoes;
- (void)getResult:(int *)dec;
/// 向外提供，手动释放
- (void)handRelease;
@end

@interface DanceGameObjc : NSObject
//- (int)gamePositionProcess:(int *)pos
//                   stepPos:(int *)stepPos
//                      rssi:(int)rssi
//               hostOrSlave:(short)hostOrSlave;
//- (void)gameBoundary:(int *)globalPos;
//- (int)getDirectionFloat:(float *)pos rssi:(int)rssi;
//- (short)danceGameProcess:(int *)pos
//                     zupt:(short)zupt
//                     rssi:(int)rssi
//              hostOrSlave:(short)hostOrSlave;
- (void)process:(int *)rightPos
       rightAtt:(int *)rightAtt
      rightZupt:(int)rightZupt
    right_press:(int)right_press
        leftPos:(int *)leftPos
        leftAtt:(int *)leftAtt
       leftZupt:(int)leftZupt
     left_press:(int)left_press
           jump:(int)jump
           down:(int)down
           rssi:(int)rssi;

- (void)getResult:(int *)matrix;
//- (float)getRssiDistance:(int)rssi;
//- (int)savePosAndRssi:(int *)pos
//                 zupt:(short)zupt
//                 rssi:(int)rssi
//          hostOrSlave:(short)hostOrSlave;
/// 向外提供，手动释放,如需要，可调用
- (void)handRelease;
@end


@interface FootStepObjc : NSObject
//pos开辟3个空间
- (void)stepCal:(int)timeStamp posList:(int *)pos zupt:(int)zupt;
- (int)getStepFreq;
- (int)getStepStatus;
- (int)getStepCount;
/// 向外提供，手动释放,如需要，可调用
- (void)handRelease;
@end


@interface InertialTrajProcessObjc : NSObject
- (void)trajRotate:(int *)pos;
//rotateMatrix只能开辟4个空间
- (void)trajRotate:(int *)pos
      rotateMatrix:(float *)rotateMatrix;
- (void)resetHeading:(short)heading;
/// 向外提供，手动释放
- (void)handRelease;
@end


//@interface OriginTrajObj : NSObject
//- (void)process:(int*)right_pos
//        right_att:(int*)right_att
//        right_zupt:(int)right_zupt
//        left_pos:(int*)left_pos
//        left_att:(int*)left_att
//        left_zupt:(int) left_zupt;
//
//- (float)getGamePos:(int)left_or_right
//               index:(int)index;
//@end

NS_ASSUME_NONNULL_END
