
#include "InertialTrajProcess.h"

#include "SingleFootAction.h"

#define  STOP_ANGLE  -0.9f

class  Interaction {
public:
	Interaction();
	void Process(int* right_pos, int* right_att, int right_zupt, int right_press,
		int* left_pos, int* left_att, int left_zupt, int left_press, int jump, int down, int rssi);

	int get_motion_state();

private:
	InertialTrajProcess rotateTrajLeft;
	InertialTrajProcess rotateTrajRight;

	int same_zupt_count;
	int canEnter;
	int stopGame;

	int motion_state;
	int can_report_motion_state;

	int left_stop_signal_count;
	int right_stop_signal_count;

	int left_last_pos[3];
	int right_last_pos[3];

	int left_last_pos_tmp[3];
	int right_last_pos_tmp[3];

	int left_zupt_last;
	int right_zupt_last;

	SingleFootAction leftFootAction = NULL;
	SingleFootAction rightFootAction = NULL;

	int time_interval;
};
